Package org.springframework.test.annotation

# Enum Class DirtiesContext.HierarchyMode

java.lang.Object
java.lang.Enum<DirtiesContext.HierarchyMode>
org.springframework.test.annotation.DirtiesContext.HierarchyMode

All Implemented Interfaces:
  `Serializable`, `Comparable<DirtiesContext.HierarchyMode>`, `Constable`

Enclosing class:
  DirtiesContext

public static enum DirtiesContext.HierarchyMode extends Enum<DirtiesContext.HierarchyMode>
Defines modes which determine how the context cache is cleared when `@DirtiesContext` is used in a test whose context is configured as part of a hierarchy via `@ContextHierarchy`.

Since:
  3.2.2

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`CURRENT_LEVEL`
The `ApplicationContext` for the current level in the context hierarchy and all contexts in subhierarchies of the current level will be removed from the context cache and closed.
`EXHAUSTIVE`
The context cache will be cleared using an exhaustive algorithm that includes not only the current level but also all other context hierarchies that share an ancestor context common to the current test.

## Method Summary

Modifier and Type
Method
Description
`static DirtiesContext.HierarchyMode`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static DirtiesContext.HierarchyMode[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### EXHAUSTIVE

public static final DirtiesContext.HierarchyMode EXHAUSTIVE
The context cache will be cleared using an exhaustive algorithm that includes not only the current level but also all other context hierarchies that share an ancestor context common to the current test.

All `ApplicationContexts` that reside in a subhierarchy of the common ancestor context will be removed from the context cache and closed.

### CURRENT_LEVEL

public static final DirtiesContext.HierarchyMode CURRENT_LEVEL
The `ApplicationContext` for the current level in the context hierarchy and all contexts in subhierarchies of the current level will be removed from the context cache and closed.

The current level refers to the `ApplicationContext` at the lowest level in the context hierarchy that is visible from the current test.

## Method Details

### values

public static DirtiesContext.HierarchyMode[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static DirtiesContext.HierarchyMode valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null